<?php

/*
Lexikon Mod von www.sehp-cms.de fr EasyHP 1.2.x
Datei: includes/lexikon.inc.php
*/

if (!defined("IN_EASYHP")) {
	die();
}

if (!LEX_AKTIV and !$admin)
{
	
	include "common.php";
	include "includes/website.php";
	print make_message(SITE_IMG, "PC-Fachbegriffe", LEX_INAKTIV, '', '');
	footer(1);
}

$buchstaben = array("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "@");

function neu($timestamp, $status)
{
	$tage = LEX_NEU_UPDATE;
	$abgelaufen = $timestamp + ($tage * 86400);
	if ($abgelaufen > time())
		if ($status == 1)
			return "<a href='lexikon.php?action=see&id=248'><img border='0' src='/images/k_new.gif' /></a>";
		else if ($status == 0)
			return "<a href='lexikon.php?action=see&id=249'><img border='0' src='/images/k_update.gif' /></a>";
}

function buchstabenliste()
{
	global $userdata, $printer;
	if (!$printer)
	{
		if ($userdata['level'] == 1)
			print "&nbsp;&nbsp;&nbsp;&nbsp;<a href='admin/lexikon.php'>Admin-bereich</a>";
		print "<a name='home'></a>";
		print '<div align="center"><font size="5">'.LEX_NAME.'</font></div><br />';
		print "<form action='lexikon.php?action=search' method='POST'>";
		print "<input size='15' maxlength='50' type='text' name ='search' />";
		print "<input type='submit' name='absenden' value='Suchen' />";
		print "</form><br /><br />";
		print "";
		print "";
		$buchstaben = array("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "1,2,3,@,...");
		print "<font size='4'><a href='lexikon.php?action=alle'>Alle</a></font>&nbsp;";
		for($i=0;$i<=26;$i++)
		{
			print "<font size='4'><a href='lexikon.php?action=letter&id=".$buchstaben[$i]."'>".$buchstaben[$i]."</a></font>&nbsp;";
		}
		print "<br /><br />";
		print "";
	}
	print "<br /><br /><table>";
}

function verstecken($versteckt, $admin = 1)
{
	if ($admin == 1)
	{
		if ($versteckt == 1)
			$checked = ' (verst.)';
		else
			$checked = '';
	}
	return $checked;
}

function search($admin)
{
	$search = mysql_real_escape_string($_POST['search']);
	$table = LEX_TABLE;
	$ergebnisse = array();
	if ($admin == 1)
	{
		$sql = 'SELECT
			id,
			name,
			versteckt,
			beschreibung
		FROM
			'.$table.'
		ORDER BY `'.$table.'`.`name`';
	}else
	{
		$sql = 'SELECT
			id,
			name,
			beschreibung
		FROM
			'.$table.'
		WHERE `versteckt` = 0
		ORDER BY `'.$table.'`.`name`';
	}
	$result = mysql_query($sql);
	if (!$result and admin == 1) {
		die ('Etwas stimmte mit dem Query nicht: '.mysql_error());
	}
	
	while ($row = mysql_fetch_assoc($result))
	{
		$seitenid = $row['id'];
		if ($row['neu'] == 2)
			$seitenid = $row['beschreibung'];
		$checked = verstecken($row[versteckt], $admin);
		$pos = stripos($row['name'], $search);
		if ($pos !== false)
		{
			print "<tr><td>";
			print "<font size='4'><a href='lexikon.php?action=see&id=".$seitenid."'>".$row['name']."</a></font>$checked";
			if ($admin == 1)
				print "</td><td><a href='lexikon.php?action=edit&id=".$row['id']."'>&auml;ndern</a>&nbsp;&nbsp;&nbsp;<a href='lexikon.php?action=del&id=".$row['id']."'>l&ouml;schen</a></td></tr>";
			$gefunden = 1;
			$ergebnisse[] = $row['id'];
		}
	}
	if (!$gefunden)
		print "<tr><td>Keine Artikel gefunden die '$search' im namen enthalten</td></tr>";
	$gefunden = "";
	print "<tr><td><br /><font size='4'>'$search' kommt in folgenden Artikeln vor:</font></td></tr>";
	$result = mysql_query($sql);
	if (!$result) {
		die ('Etwas stimmte mit dem Query nicht: '.mysql_error());
	}
	while ($row = mysql_fetch_assoc($result))
	{
		$checked = verstecken($row[versteckt], $admin);
		$pos = stripos($row['beschreibung'], $search);
		if ($pos !== false)
		{
			if(!in_array($row['id'],$ergebnisse))
			{
				print "<tr><td>";
				print "<font size='4'><a href='lexikon.php?action=see&id=".$row['id']."'>".$row['name']."</a></font>$checked";
				if ($admin == 1)
					print "</td><td><a href='lexikon.php?action=edit&id=".$row['id']."'>&auml;ndern</a>&nbsp;&nbsp;&nbsp;<a href='lexikon.php?action=del&id=".$row['id']."'>l&ouml;schen</a></td></tr>";
				else
					print "</td></tr>";
				$gefunden = 1;
			}
		}
	}
	if (!$gefunden)
		print "<tr><td>keine Suchergebnisse</td></tr>";
}

function alle_zeigen($admin, $result, $letters = 1)
{
	print "<table>";
	while ($row = mysql_fetch_assoc($result)) 
	{
		$seitenid = $row['id'];
		$checked = verstecken($row[versteckt], $admin);
		$buchstabe = strtoupper($row['name'][0]);
		
		if ($row['neu'] == 2)
			$seitenid = $row['beschreibung'];
		if ($letters == 1)
		{
			if ($buchstabe != $letzterbuchstabe)
			{
				print "<tr><td>";
				if ($buchstabe != "A")
					print "<a href='lexikon.php#home'>nach oben</a><br /><br />";
				print "<font size='4'><b>".$buchstabe."</b></font>";
				print "</td></tr>";
				$letzterbuchstabe = $buchstabe;
			}
			$neu = neu($row['erstellt'], $row['neu']);
		}else
			$neu = "(".date("d.m.Y",$row['erstellt']).")";
		print "<tr><td>";
		print "<font size='4'><a href='lexikon.php?action=see&id=".$seitenid."'>".$row['name']."</a></font> $neu $checked";
		if ($admin == 1)
			print "</td><td><a href='lexikon.php?action=edit&id=".$row['id']."'>&auml;ndern</a>&nbsp;&nbsp;&nbsp;<a href='lexikon.php?action=del&id=".$row['id']."'>l&ouml;schen</a></td></tr>";
		else
			print "</td></tr>";
	}
}

function einen_zeigen($admin, $admin_folder = "", $back = "")
{
	global $printer;
	$site_id = mysql_real_escape_string($_GET['id']);
	buchstabenliste();
	print "</table>";
	if (!$site_id)
	{
		$fehler = make_message(SITE_IMG, "PC-Fachbegriffe", "bitte eine ID angeben", '', '');
		die($fehler);
	}
	$table = LEX_TABLE;
	$sql = 'SELECT
		id,
		name,
		versteckt,
		beschreibung,
		erstellt,
		notiz,
		neu
	FROM
		'.$table.'
	WHERE `id` ='.$site_id;
	
	$result = mysql_query($sql);
	if (!$result and $admin) {
		echo ('Etwas stimmte mit dem Query nicht: '.mysql_error());
	}
	if (!$result) {
		$fehler = make_message(SITE_IMG, "PC-Fachbegriffe", "Diese Seite funktioniert im moment nicht", '', '');
		die($fehler);
	}
	if (!$result or mysql_num_rows($result) <= 0)
	{
		die ("Diesen Lexikonartikel gibt es nicht");
	}
	
	while ($row = mysql_fetch_assoc($result)) 
	{
		$checked = verstecken($row[versteckt], $admin);
		print "<div align='center'><font size='3'><b>".$row['name']."</b></font>$checked</div>";
		print "<font size='3'>".$row['beschreibung']."</font><br />";
		if ($row['neu'] == 1)
			$status = "Artikel hinzugef&uuml;gt";
		else if ($row['neu'] == 0)
			$status = "Artikel ver&auml;ndert";
		else
			$status = "Weiterleitung eingerichtet";
		
		print "<br /><font size='1'>$status: ".date("d.m.Y",$row['erstellt'])."</font>";
		if (!$printer and LEX_PRINT)
			print "<br /><br /><a href='javascript:openwindow(\"print.php?site=lexikon&action=see&id=$site_id\")'><img src='images/printer.png' alt='Diesen Artikel drucken' title='Diesen Artikel drucken' /></a><noscript>(Javascript erforderlich <a href='print.php?site=lexikon&action=see&id=$site_id'>alternativer Link</a>)</noscript><br /><br />";
		if ($admin == 1  and !$printer)
		{
			print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href='".$admin_folder."lexikon.php?action=edit".$back."&id=".$row['id']."'>&auml;ndern</a>&nbsp;&nbsp;&nbsp;<a href='".$admin_folder."lexikon.php?action=del&id=".$row['id']."'>l&ouml;schen</a>";
			if ($row['notiz'])
				print "<br /><br /><b>Interne Notizen: </b><br />".$row['notiz'];
			print "<br /><br /><a href='".$admin_folder."lexikon.php?see=3&weiterleitung=".$row['id']."&action=feedback'>alle Feedbacks zu dem Artikel</a>";
		}
		if ($_GET['action'] != "feedback" and LEX_AKTIV_FB and !$printer)
		{
			print "<br /><br /><a href='lexikon.php?action=feedback&id=$site_id'>Meinung abgeben / Fragen zu dem Artikel</a>";
		}
	}
}

function buchstaben_zeigen($admin, $buchstabe = "", $anzahl =0)
{
	buchstabenliste();
	if ($admin  == 1)
	{
		print "<a href='lexikon.php?action=new'>neu</a>";
		print "<br /><a href='lexikon.php?action=versteckt'>alle versteckten</a>";
	}
	if (!$buchstabe)
	{
		$buchstabe = mysql_real_escape_string($_GET['id']);
		$buchstabe = strtoupper($buchstabe[0]);
	}
	if (ord($buchstabe) > 64 and ord($buchstabe) < 91)
	{
		$table = LEX_TABLE;
		if ($admin == 1)
		{
			$sql = 'SELECT
				id,
				neu,
				versteckt,
				beschreibung,
				name
			FROM
				'.$table.'
			WHERE `name` LIKE CONVERT(_utf8 \''.$buchstabe.'%\' USING latin1)
			COLLATE latin1_swedish_ci
			ORDER BY `'.$table.'`.`name`;';
		}else
		{
			$sql = 'SELECT
				id,
				neu,
				erstellt,
				name,
				beschreibung
			FROM
				'.$table.'
			WHERE `name` LIKE CONVERT(_utf8 \''.$buchstabe.'%\' USING latin1)
			COLLATE latin1_swedish_ci and `versteckt` = 0
			ORDER BY `'.$table.'`.`name`;';
			if ($anzahl != 0)
				print "Es gibt $anzahl Artikel im Lexikon hier werden nur die mit dem Buchstaben $buchstabe ausgegeben<br />";
		}
	}else
	{
		$sonder = 1;
		$buchstabe = "1 bis 9, @, !, %, &, /, (, ), =, ?, ...";
		$sql = 'SELECT
			id,
			neu,
			versteckt,
			beschreibung,
			name
		FROM
			'.LEX_TABLE.'
		WHERE `versteckt` = 0';
		if ($anzahl != 0)
			print "Es gibt $anzahl Artikel im Lexikon hier werden nur die mit den Sonderzeichen ausgegeben";
	}

	
	$result = mysql_query($sql);
	if (!$result and $admin) {
		die ('Etwas stimmte mit dem Query nicht: '.mysql_error());
	}
	if (!$result) {
		$fehler = make_message(SITE_IMG, "PC-Fachbegriffe", "Diese Seite funktioniert im moment nicht", '', '');
		die($fehler);
	}
	print "<table>";
	print "<tr><td>";
	print "<font size='4'><b>".$buchstabe."</b></font>";
	print "</td></tr>";
	while ($row = mysql_fetch_assoc($result)) 
	{
		$asciie = ord(strtoupper($row['name'][0]));
		if ((($asciie > 64) and ($asciie < 91)) and $sonder)
			continue;
		
		$seitenid = $row['id'];
		$neu = neu($row['erstellt'], $row['neu']);
		if ($row['neu'] == 2)
			$seitenid = $row['beschreibung'];
		$checked = verstecken($row[versteckt], $admin);
		print "<tr><td><font size='4'><a href='lexikon.php?action=see&id=".$seitenid."'>".$row['name']."</a></font>$checked $neu";
		if ($admin == 1)
			print "</td><td><a href='lexikon.php?action=edit&id=".$row['id']."'>&auml;ndern</a>&nbsp;&nbsp;&nbsp;<a href='lexikon.php?action=del&id=".$row['id']."'>l&ouml;schen</a></td></tr>";
		else
			print "</td></tr>";
		$vorhanden = True;
	}
	print "</table>";
	if (!$vorhanden)
	{
		if ($sonder)
			print "<br /><br />F&uuml;r diese Zeichen gibt es keinen Artikel";
		else
			print "<br /><br />F&uuml;r diesen Buchstaben gibt es keinen Artikel";
	}	
}

function get_artikelname($id)
{
	$sql = 'SELECT
		name
	FROM
		'.LEX_TABLE.'
	WHERE `id` ='.$id;
	$result = mysql_query($sql);
	if (mysql_num_rows($result) <= 0)
		return "unbekannt";
	$row = mysql_fetch_assoc($result);
	return $row['name'];
}

function get_username_link($id, $nurname=0)
{
	$sql = 'SELECT
		name
	FROM
		'.USERS_TABLE.'
	WHERE `id` ='.$id;
	$result = mysql_query($sql);
	if (mysql_num_rows($result) <= 0)
		return "unbekannt";
	$row = mysql_fetch_assoc($result);
	if ($nurname == 1)
		return $row['name'];
	return "<a href='../privmsg.php?mode=new&to=$id'>".$row['name']."</a>";
}



function weiterleitung()
{
	$site_id = mysql_real_escape_string($_GET['id']);	
	$sql = 'SELECT
		id,
		beschreibung,
		neu
	FROM
		'.LEX_TABLE.'
	WHERE `id` = '.$site_id.'
	ORDER BY `'.LEX_TABLE.'`.`name`';
	$result = mysql_query($sql);
	if (!$result and admin == 1) {
		die ('Etwas stimmte mit dem Query nicht: '.mysql_error());
	}
	else if ($result)
		$row = mysql_fetch_assoc($result);
	if ($row['neu'] == 2)
	{
		$seitenid = $row['beschreibung'];
		$header = "Location: lexikon.php?action=see&id=$seitenid";
		return $header;
	}
}
?>